<?php
namespace Geral\Repositories;

class Filial extends \Doctrine\ORM\EntityRepository
{

    public function retornaFilialPorOperador($operador, $nrorg) {

    $stmt = $this->getEntityManager()->getConnection()->prepare("SELECT 
        FILIAL.NMFILIAL, 
        FILIAL.CDEMPRESA,
        FILIAL.CDREGIAO,
        FILIAL.CDFILIAL, 
        FILIAL.NRORG, 
        ESTRUTURAS.NRESTRUTURAM, 
        DECODE(FILIAL.CDFILCENTCMP, NULL, FILIAL.CDFILIAL, FILIAL.CDFILCENTCMP) AS CDFILCENTCMP 
      FROM FILIAL JOIN (SELECT 
        ESTRUTURAM.NRESTRUTURAM NRESTRUTURAM, 
        ESTRUTURAM.NRORG NRORGESTRUTURA, 
        ESTRUTURAM.CDINTESTRUTURA, 
        ESTRUTURAM.NRTIPOESTRUTURA 
      FROM HIERARQUIAORG JOIN ESTRUTURAM ON 
      ESTRUTURAM.NRORG = HIERARQUIAORG.NRORG AND 
      ESTRUTURAM.NRESTRUTURAM = HIERARQUIAORG.NRESTRUTURAMREL 
      WHERE 
      NRTIPOESTRUTURA = 2 AND
      ESTRUTURAM.NRORG = :NRORG
      START WITH NRESTRUTURAMREL IN (SELECT
      NRESTRUTURAMREL
      FROM ESTRUTURAOPER
      JOIN ORGANIZACAOOPER ON
      ORGANIZACAOOPER.NRORGANIZACAOOPER = ESTRUTURAOPER.NRORGANIZACAOOPER
      AND ORGANIZACAOOPER.NRORG = ESTRUTURAOPER.NRORG
      WHERE ORGANIZACAOOPER.CDOPERADOR = :OPERADOR
      AND ORGANIZACAOOPER.NRORG = :NRORG)
      CONNECT BY PRIOR NRESTRUTURAMREL = NRESTRUTURAMSUP)
      ESTRUTURAS ON ESTRUTURAS.NRORGESTRUTURA = FILIAL.NRORG AND 
      ESTRUTURAS.CDINTESTRUTURA = FILIAL.CDFILIAL AND 
      FILIAL.IDCNTRRESC = 'N'
      ORDER BY FILIAL.CDFILIAL
    ");

    $stmt->execute(
      array(
        "OPERADOR" => $operador,
        "NRORG" => $nrorg
      )
    );

      return $stmt->fetchAll();

  }
  
    /**
     * @param $cdfilial
     * @param $nrorg
     * @return array
     * @throws \Exception
     */
    public function consultaFilialCentralizadora($cdfilial, $nrorg)
    {
        $sql = <<<SQL
        SELECT L.CDFILIFISC, F.CDSERIE, F.CDEMPRESA, F.CDINSCESTA,
               F.CDINSCMUNI, P.DTPROCESSA
          FROM FILIAL L
          JOIN FILIAL F
          ON L.CDFILIFISC = F.CDFILIAL
          JOIN PARAMFILIAL P
          ON P.CDFILIAL   = L.CDFILIFISC
         WHERE L.CDFILIAL   = :CDFILIAL
         AND L.NRORG = :NRORG
SQL;
        try{
            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRORG" => $nrorg
            );

            return $this->getEntityManager()->getConnection()->fetchAssoc($sql, $params);
        }catch(\Exception $e) {
            throw $e;
        }
    }
    public static function mudarRegiao($cdRegiao, $nrorg, $cdFilial){
        $sql="update filial set cdregiao=$cdRegiao where nrorg='$nrorg' and cdfilial='$cdFilial'";
        $this->getEntityManager()->getConnection()->executeQuery($sql);
    }


    public function consultaFilialPorGrupo($nrorg, $cdgrupfili){
        $sql = 'SELECT * FROM (SELECT FILIAL.CDFILIAL,
                         FILIAL.NMFILIAL,
                         FILIAL.NRORG,
                         FILGRUPFILI.CDGRUPFILI
                  FROM FILIAL
                  INNER JOIN FILGRUPFILI
                    ON FILIAL.NRORG    = :NRORG
                   AND FILGRUPFILI.CDGRUPFILI = :CDGRUPFILI
                   AND FILIAL.CDFILIAL = FILGRUPFILI.CDFILIAL
                ORDER BY CDFILIAL
                ) FILIAL';


        $params = array(
            'NRORG' => $nrorg,
            'CDGRUPFILI' => $cdgrupfili,
        );

        $entityManager = $this->getEntityManager();
        $result = $entityManager->getConnection()->fetchAll($sql, $params);
        return count($result)>0 ? $result : array();
    }

	public function consultaDadosFilial($cdempresa, $cdfilial){
    	$sql = 'SELECT CDFILIAL    , NMFILIAL  , CDEMPRESA, CDINSCESTA, CDINSCMUNI,
				       NRTAMNUMNFUT
				FROM(SELECT FI.CDFILIAL  , FI.NMFILIAL  , FI.CDEMPRESA   ,
				            FI.CDINSCESTA, FI.CDINSCMUNI, NVL(PF.NRTAMNUMNFUT,0) AS NRTAMNUMNFUT,
				            FI.CDCENTCUST
				     FROM PARAMFILIAL PF, FILIAL FI
				     WHERE (FI.CDEMPRESA = :P_CDEMPRESA) AND
				           (FI.CDFILIAL  = :P_CDFILIAL ) AND
				           (PF.CDFILIAL  = FI.CDFILIAL )
				     UNION
				     SELECT EF.CDFILIAL  , FI.NMFILIAL    , EF.CDEMPRESA , EF.CDINSCESTA,
				            EF.CDINSCMUNI, NVL(PF.NRTAMNUMNFUT,0) AS NRTAMNUMNFUT, FI.CDCENTCUST
				     FROM PARAMFILIAL PF, FILIAL FI, EMPRCNTRFIL EF
				     WHERE (EF.CDEMPRESA = :P_CDEMPRESA) AND
				           (EF.CDFILIAL  = :P_CDFILIAL ) AND
				           (FI.CDFILIAL  = EF.CDFILIAL ) AND
				           (PF.CDFILIAL  = FI.CDFILIAL )) A
				ORDER BY CDFILIAL';
    
		try{
			$params = array(
					'P_CDEMPRESA' => $cdempresa,
					'P_CDFILIAL' => $cdfilial,
			);
		
			$entityManager = $this->getEntityManager();
			$result = $entityManager->getConnection()->fetchAll($sql, $params);
			return $result;
		}catch(\Exception $e){
			throw $e;
		}
    }

    public function maxCdfilial()
    {
        $sqlMax = "SELECT MAX(TO_NUMBER(CDFILIAL))+1 FROM FILIAL";
        $result = $this->getEntityManager()->getConnection()->fetchColumn($sqlMax);
        return ($result) ? $result : false;
    }

    /**
     * Verifica se filial pode inserir Destino da Solicitação
     * @param $nrorg
     * @param $cdfilial
     * @return array
     * @throws \Exception
     */
    public function verificaFilialPossuiDestsol($nrorg, $cdfilial)
    {
        $query = "SELECT PARASUPRI.IDULTDESTSOL
                  FROM PARCMPSUP,
                      PARASUPRI,
                      FILIAL
                  WHERE PARCMPSUP.CDFILIAL = FILIAL.CDFILIAL
                  AND PARASUPRI.CDFILIAL   = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)
                  AND FILIAL.CDFILIAL      = :P_CDFILIAL
                  AND FILIAL.NRORG         = :P_NRORG
                  AND PARASUPRI.NRORG      = FILIAL.NRORG
                  AND PARCMPSUP.NRORG      = FILIAL.NRORG";

        $params = array('P_NRORG' => $nrorg, 'P_CDFILIAL' => $cdfilial);

        try {
            return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function atualizaProdutosFilial($cdfilial, $idcontrestoq, $idutctrllote, $cdnvproduto){
        $sql = <<<SQL
            INSERT INTO PRODFILI(CDFILIAL, CDPRODUTO, IDCNTRESTOQ, IDUTCTRLLOTE)
            (SELECT :P_CDFILIAL, CDPRODUTO, :P_IDCNTRESTOQ, :P_IDUTCTRLLOTE
               FROM PRODUTO
              WHERE CDNVPRODUTO = :P_CDNVPRODUTO
                AND IDPRODATIVPR = 'S'
                AND NOT EXISTS (SELECT :P_CDFILIAL, CDPRODUTO, :P_IDCNTRESTOQ, :P_IDUTCTRLLOTE
                                  FROM PRODFILI
                                 WHERE PRODFILI.CDFILIAL  = :P_CDFILIAL
                                   AND PRODFILI.CDPRODUTO = PRODUTO.CDPRODUTO))
SQL;
        $params = array(
            ":P_CDFILIAL" => $cdfilial,
            "P_IDCNTRESTOQ" => $idcontrestoq,
            "P_IDUTCTRLLOTE" => $idutctrllote,
            "P_CDNVPRODUTO" => $cdnvproduto
        );
        $this->getEntityManager()->getConnection()->executeQuery($sql, $params);

    }
}