<?php

require_once 'base/VendedorEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 *
 * @author  gustavo
 */
class VendedorEntity extends VendedorEntityBase
{


    /**
     * Consulta vendedor através do Nº do parceiro de negócios.
     *
     * @param string $nrparc Nº do parceiro de negócios.
     * @param string $nrorg  Nº Organização.
     *
     * @return Ambigous <mixed, NULL>
     */
    public static function consultaVendedorParceiro($nrparc, $nrorg){
        return Vendedor::consultaVendedorParceiro($nrparc, $nrorg);
    }


    /**
     * Consulta vendedor através do código de operador.
     *
     * @param integer $cdopera Código do operador.
     * @param integer $nrorg   Nº Organização.
     *
     * @return Ambigous <mixed, NULL>
     */
    public static function consultaVendedorOperador($cdopera, $nrorg){
        return Vendedor::consultaVendedorOperador($cdopera, $nrorg);
    }
    
    /**
     * Deleta registro de Vendedor.
     * 
     * @param integer $nrparcnegocio 	Numero do Parceiro de Negócio
     * @param integer $nrorg 		 	Numero da Organização
     *  
     * @return void
     *
     * @author gustavosilva - 29/05/2012
     */
    public static function deleteVendedorFromNrparcnegocio($nrparcnegocio, $nrorg){
    	
    	Vendedor::deleteVendedorFromNrparcnegocio($nrparcnegocio, $nrorg);
    	
    }
    
    /**
     * Cria um novo registro de Vendedor.
     * 
     * @param integer $nrparcnegocio 	Numero do Parceiro de Negócio
     * @param integer $nrorg 		 	Numero da Organização
     * @param string  $nome			 	Nome do funcionário
     * @param string  $nomereduzido		Nome Reduzido do Fornecedor
     * @param string  $inscricao	 	Identificador da Inscrição
     * @param integer $nrinscricaoparc	Numero da Inscrição do parceiro
     *  
     * @return void
     *
     * @author gustavosilva - 29/05/2012
     */
    public static function createNewVendedor($nrparcnegocio, $nrorg, $nome, $nomereduzido, $tipoinscricao, $nrinscricao){
    	try{
	    	$vendedor = new self();
	    	$vendedor->setNrparcnegocio($nrparcnegocio);
	    	$vendedor->setNmrazsocven($nome);
	    	$vendedor->setNmfanven($nomereduzido);
	    	$vendedor->setNrorg($nrorg);
	    	$vendedor->setNrinsjurven($nrinscricao);
	    	$vendedor->setCdvendedor(Novocodigo::geraCodigo(Ambiente::getNrorg(), 'VENDEDOR', 4));
	    	$vendedor->setIdtpijurven($tipoinscricao);
	    	FctUtil::newEntityAudit($vendedor);
	    	$vendedor->persist();
    	}catch(Exception $e){
    		throw $e;
    	}
    }


}

